#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <queue>

#define all(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define Vec(a) for(auto x : a)cout<<x<<' ';
#define setsp setprecision
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll N = 300000;
vector<ll> Graph[N];
bool used[N];
ll dist[N];
ll used2[N];
void dfs(ll node, ll k) {
    used[node] = true;
    used2[node] = 1;
    for (ll to : Graph[node]) {
        if (used2[to] != 1 and k != 0)dfs(to, k - 1);
    }
    used2[node] = 2;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        Graph[a].push_back(b);
        Graph[b].push_back(a);
    }
    if (n == m + 1) {
        for (int i = 0; i < k; i++) {
            ll pos, d;
            cin >> pos >> d;
            dfs(pos, d);
        }
        vector<ll> ans;
        for (int i = 1; i <= n; i++) {
            if (used[i])ans.push_back(i);
        }
        cout << ans.size() << endl;
        Vec(ans);
        return 0;
    }
    queue<pair<ll, ll>> q;
    for (int i = 0; i < k; i++) {
        ll pos, d;
        cin >> pos >> d;
        q.push(make_pair(pos, d));
        used[pos] = true;
        dist[pos] = d;
    }
    while (!q.empty()) {
        ll x = q.front().first, d = q.front().second;
        q.pop();
        if (d == 0)continue;
        for (ll to : Graph[x]) {
            if (!used[to] or used[to] and dist[to] < d - 1) {
                used[to] = true;
                dist[to] = d - 1;
                q.push(make_pair(to, d - 1));
            }
        }
    }
    vector<ll> ans;
    for (int i = 1; i <= n; i++) {
        if (used[i])ans.push_back(i);
    }
    cout << ans.size() << endl;
    Vec(ans);
    return 0;
}